/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: IsWidInFocus.c /main/7 1995/07/14 11:40:35 drk $"
#endif
#endif
/***********************************************************************
  	@(#)IsWidInFocus.c	1.4.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/30/90 SJS add to sccs
	Calls:

	Summary:
            Returns True if widget is in keyboard focus.

        INPUTS:
            none
        
        OUTPUTS:
            none

        RETURNS:
            True = widget is in keyboard focus
            False = widget is not in keyboard focus
************************************************************************/

#include <AutoMessages.h>
#include "xislib.h"

int xisIsWidgetInKeyboardFocus(bool)
int bool;
{
    int result;

    XisObjectRecord *focus_object = xisGetFocusObject();

    if (!xisInform.is_valid) 
       AutoMessage (_AutoMessages[WARNMSG56]);

    if (focus_object->id.widget == xisInform.current_obj->id.widget)
        result = bool;
    else
        result = (!bool);

    return (result);

} /* End xisIsWidgetInKeyboardFocus() */

/***********************************************************************
  	Author: PSN
	History:
            08/29/90 PSN first cut
	Calls:

	Summary:
            Returns True if widget's parent is in keyboard focus.

        INPUTS:
            none
        
        OUTPUTS:
            none

        RETURNS:
            True = widget's parent is in keyboard focus
            False = widget's parent is not in keyboard focus
************************************************************************/

int xisIsParentWidgetInKeyboardFocus(bool)
int bool;
{
    int result;

    XisObjectRecord *focus_object = xisGetFocusObject();

    if (!xisInform.is_valid) 
       AutoMessage(_AutoMessages[WARNMSG57]);

    if (focus_object->id.widget == XtParent(xisInform.current_obj->id.widget))
        result = bool;
    else
        result = (!bool);

    return (result);

} /* End xisIsParentWidgetInKeyboardFocus() */
