/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: ChkCmpTmpVis.c /main/5 1995/07/14 11:47:16 drk $"
#endif
#endif
/***********************************************************************
  	Author: REC
	History:
	    04/15/93 Created by REC
	Calls:

	Summary:
	    Called to determine the current mode when a compare temp 
	    visaul command is executed.  Compare the current imagage
	    against a stored temp image only if running in a compare 
	    (batch or interactive) mode.

        INPUTS:
            widget - the widget whose image needs comparing or capturing
	    identifier - the tag assocated with an image
        
        OUTPUTS:
            none

        RETURNS:
            nothing
************************************************************************/
#include <AutoMessages.h>
#include "vislib.h"

void mvsCheckCompareTempVisual(widget_info, identifier)
MvsWidgetInfoRecord *widget_info;
char *identifier;
{

    char msg_string[125];
  
    if (XmIsGadget(widget_info->widget))
        widget_info = widget_info->parent;

    switch (mvsVisualMode) {
        case VISUAL_MODE_DONT_CHECK:
        case VISUAL_MODE_GENERATE_PIXMAPS:
            /* mvsImageFd = 0; */
            break;

        case VISUAL_MODE_BATCH_COMPARE:
	    mvsCompareStoredPixmapBatch(widget_info, identifier);
	    break;

        case VISUAL_MODE_INTERACTIVE_COMPARE:
	    mvsCompareStoredPixmapInt(widget_info, identifier);
            break;

	default:
	    sprintf(msg_string, _AutoMessages[VISMSG45], mvsVisualMode);
	    AutoMessage(msg_string);
    }

} /* End mvsCheckCompareTempVisual() */
