/* $XConsortium: StringToByte.c /main/5 1995/07/15 21:13:08 drk $ */
/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 */
#include <stdio.h>

#include <testlib.h>

void
main( int argc, char **argv )
{
	XmString	string1, string2;
	unsigned char	*byte_stream;
	unsigned int	length1, length2, length3;
        Boolean         same;

     CommonTestInit( argc, argv );

    /*
     *  Create an XmString.
     *  Convert the XmString to a byte stream and back again.
     *  Verify that the converted XmString is the same as the
     *  original.
     */
     string1 = XmStringCreateLtoR("Original", XmFONTLIST_DEFAULT_TAG ); 

     length1 = XmCvtXmStringToByteStream( string1, &byte_stream );

     string2 = XmCvtByteStreamToXmString( byte_stream ); 

     same = XmStringCompare( string1, string2 );

     printf("XmCvtXmStringToByteStream with non-Null byte stream parameter: ");
     if ( same )
        printf("passed.");
     else
        printf("failed.");

     printf("\n\n");


    /*
     *  Verify that the correct length is returned when the byte
     *  stream ( second ) parameter is passed in as Null.
     *  The function should return the length in this instance.
     */
     length2 = XmCvtXmStringToByteStream( string1, (unsigned char **)0 );

     printf("XmCvtXmStringToByteStream with Null byte stream parameter: ");
     if ( length1 == length2 )
        printf("passed.");
     else
        printf("failed.");

     printf("\n\n");

     length3 = XmStringByteStreamLength( byte_stream );  

     printf("XmStringByteStreamLength: ");
     if ( length1 == length3 )
        printf("passed.");
     else
        printf("failed.");

     printf("\n\n");

     CommonPause();

     XmStringFree( string1 );
     XmStringFree( string2 );
     XtFree( byte_stream );
     XtAppMainLoop( app_context );
}
